    ; Public Domain test grid generator by Eric Auer 2004
    ; To compile: http://nasm.sourceforge.net/ command:
    ; NASM -o testpage.com testpage.asm

    org 0x100

%define COLS 71 ; e.g. 71
%define ROWS 51 ; e.g. 51

start:
    xor cx,cx   ; Y
yloop:

    ; *** Line with crossings
    xor bx,bx   ; X

    mov ax,0x0cdc4   ; double = or single -
    xchg bx,cx  ; abuse ifcolum as ifrow
    call ifcolumn
    xchg bx,cx
    mov dl,al   ; save appropriate - or =

xloop0:
    test bx,1   ; column with crossing?
    jz yline0  ; if not ...
    mov al,dl   ; else use appropriate - or =
    jmp nextcol0

yline0:
    mov ax,0x0d7c5   ; assume -!!- or -!-
    cmp dl,0x0c4 ; single - style?
    jz singlecross
; doublecross:
    mov ax,0x0ced8   ; else double style: =!!= or =!=
singlecross:
    call ifcolumn

nextcol0:
    call tty
    inc bx      ; next column
    cmp bx,COLS ; all done?
    jb xloop0

    call nextline
    cmp cx,ROWS ; all lines done?
    jae done    ; then abort here


    ; *** Line with only vertical lines and spaces
    xor bx,bx   ; X
xloop1:
    test bx,1   ; column with sign?
    jz yline   ; if not ...
    mov al,' '  ; else space
    jmp nextcol

yline:
    mov ax,0x0bab3   ; AH = ! / AL = !!
    call ifcolumn

nextcol:
    call tty
    inc bx      ; next column
    cmp bx,COLS ; all done?
    jb xloop1

    call nextline

    cmp cx,ROWS ; all lines done?
    jb yloop    ; else loop around

done:
    mov ax,0x4c00   ; leave to DOS
    int 0x21


ifcolumn:       ; return AL, but if BX is multiple of 10 return AH
    push ax
    mov ax,bx
    aam         ; ah = al / 10,   al = al mod 10
    test al,al  ; multiple of 10?
    pop ax
    ; mov al,al ; assume normal
    jnz othercol
    mov al,ah   ; if multiple of 10, use special instead
othercol:
    ret


nextline:
    mov al,13   ; CR
    call tty
    mov al,10   ; LF
    call tty
    inc cx      ; next line
    ret


tty:
    push ax
    push dx
    mov ah,2    ; output to CON and check for ^C
    mov dl,al   ; the char
    int 0x21    ; call DOS
    pop dx
    pop ax
    ret
    
%if 0
    db 0xc4 ; single -
    db 0xcd ; double =

    db 0xb3 ; single !
    db 0xba ; double !!

    db 0xc5 ; -!-
    db 0xd7 ; -!!-
    db 0xd8 ; =!=
    db 0xce ; =!!=
%endif

